package com.futu.course.common.handle;


import com.futu.course.common.annotation.CurrentUser;
import com.futu.course.common.utils.TokenUtils;
import org.springframework.core.MethodParameter;
import org.springframework.web.bind.support.WebDataBinderFactory;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.method.support.HandlerMethodArgumentResolver;
import org.springframework.web.method.support.ModelAndViewContainer;

/**
 * @className: CurrentUserHandle
 * @Description:
 * @author: zhangxiong
 * @date: 2022/5/5/0005 16:49
 */
public class CurrentUserHandler implements HandlerMethodArgumentResolver {
    @Override
    public boolean supportsParameter(MethodParameter parameter) {
        return parameter.hasParameterAnnotation(CurrentUser.class);
    }

    @Override
    public Object resolveArgument(MethodParameter parameter, ModelAndViewContainer mavContainer, NativeWebRequest webRequest, WebDataBinderFactory binderFactory) throws Exception {
        String authorization = webRequest.getHeader("token");
        //从token中拿到userId
        Long userId = TokenUtils.getUserId(authorization);
        return userId;
    }
}
